// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/api/dev_access.h $
// $Rev: 30377 $
// $Date: 2014-09-18 12:09:04 -0500 (Thu, 18 Sep 2014) $

#ifndef __DEV_ACCESS_H__
#define __DEV_ACCESS_H__

#include "gsc_irq.h"

#include "dev_io.h"



// data types *****************************************************************

struct _dev_data_t
{
	gsc_sem_t		sem;
	gsc_device_t	device;
	gsc_bar_t		plx_regs;
	gsc_bar_t		gsc_regs;
	gsc_dma_t		dma;
	dev_io_t		tx;
	dev_io_t		rx;
	U32				strict_args;	// Enforce strict argument compliance.
	U32				strict_config;	// Enforce strict configuration compliance.
	U32				favor_tx;		// Favor Tx? If not, then Rx.

	struct
	{
		gsc_irq_t		girq;		// GSC IRQ data
		gsc_event_t*	local;		// PLX: local interrupt event
		gsc_event_t*	locals[16];	// Local interrupt event handling.
	} irq;

	struct
	{
		int		bus_width;		// 32 or 64
		U32		frr;			// Firmware Revision Register
		U32		fsr;			// Feature Set Register
		U32		tfsr;			// Tx FIFO Size Register
		U32		rfsr;			// Rx FIFO Size Register
		int		single_cycle_disable;
		int		user_jumpers;
	} cache;
};



// prototypes *****************************************************************

U32		dev_access_lock(void* handle, dev_data_t** dev);
void	dev_access_unlock(dev_data_t* dev);



#endif
