// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/api/gsc_bar.h $
// $Rev: 30377 $
// $Date: 2014-09-18 12:09:04 -0500 (Thu, 18 Sep 2014) $

#ifndef __GSC_BAR_H__
#define __GSC_BAR_H__

#include "gsc_access.h"



// data types *****************************************************************

typedef struct
{
	gsc_device_t*	device;
	U8				index;		// The X in "BARX".
	U32				reg;		// The GSC definition of the PCI register.
	U32				address;	// physical address
	U32				size;		// In bytes.
	U32				io_space;	// In I/O space?
	void*			ptr;		// Pointer usable by library.
} gsc_bar_t;



// prototypes *****************************************************************

U32		gsc_bar_create(gsc_bar_t* bar, gsc_device_t* device, U32 index, U32 reg);
U32		gsc_bar_destroy(gsc_bar_t* bar);
U32		gsc_bar_map(gsc_bar_t* bar);
U32		gsc_bar_reg_mod(const gsc_bar_t* bar, U32 reg, U32 value, U32 mask);
U32		gsc_bar_reg_read(const gsc_bar_t* bar, U32 reg, U32* value);
U32		gsc_bar_reg_write(const gsc_bar_t* bar, U32 reg, U32 value);
U32		gsc_bar_unmap(gsc_bar_t* bar);



#endif
