// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/api/gsc_os_time.c $
// $Rev: 30377 $
// $Date: 2014-09-18 12:09:04 -0500 (Thu, 18 Sep 2014) $

#include <unistd.h>
#include <sys/time.h>

#include "gsc_os_time.h"



/******************************************************************************
*
*	Function:	os_time_delta_ms
*
*	Purpose:
*
*		Return a relative change in time in milliseconds. The change in time
*		must be relative to a fixed point in time.
*
*	Arguments:
*
*		None.
*
*	Returned:
*
*		The change in time in milliseconds.
*
******************************************************************************/

U32 os_time_delta_ms(void)
{
	static	int				started	= 0;
	static	struct timeval	start;

	U32						delta;
	U32						sec;
	struct timeval			tv;
	U32						us;

	if (started == 0)
	{
		gettimeofday(&start, NULL);
		started	= 1;
	}

	gettimeofday(&tv, NULL);
	sec		= tv.tv_sec - start.tv_sec;
	us		= 1000000L + tv.tv_usec - start.tv_usec;
	sec		+= us / 1000000L;
	us		= us % 1000000L;
	delta	= (sec * 1000) + (us / 1000);
	return(delta);
}


