// This software is covered by the GNU GENERAL PUBLIC LICENSE (GPL).
// Any Device - Driver - Linux
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/driver/kernel_2_2.h $
// $Rev: 23671 $
// $Date: 2013-10-31 16:23:27 -0500 (Thu, 31 Oct 2013) $
//
//	Provide special handling for things specific to the 2.2 kernel.
//

#ifndef __KERNEL_2_2_H__
#define __KERNEL_2_2_H__

#if	(LINUX_VERSION_CODE >= KERNEL_VERSION((2),2,0)) && \
	(LINUX_VERSION_CODE <  KERNEL_VERSION(2,3,0))

#include <asm/spinlock.h>
#include <linux/malloc.h>
#include <linux/wrapper.h>



/* #defines	**************************************************************/

#define	__GFP_NOWARN				0
#define	CURRENT_PROCESS_ID			current->pgrp
#define	DMA_SGL_SUPPORT_FIELD		/* SGL not supported in 2.2 drivers */
#define	EVENT_RESUME_IRQ(q,c)		wake_up_interruptible(q)
#define	EVENT_WAIT_IRQ_TO(q,c,t)	interruptible_sleep_on_timeout(q,t)
#define	GET_PAGE(page)				atomic_inc(&(page)->count)
#define	GSC_HAVE_IOCTL_BKL			1	// Big Kernel Lock based ioctl()
#define	IOCTL_SET_BKL(_ptr,_func)	(_ptr)->ioctl = (_func)
#define	IOCTL_SET_COMPAT(p,f)
#define	IOCTL_SET_UNLOCKED(p,f)
#define	KILL_FASYNC(q,s,b)			kill_fasync((q),(s),(b))
#define	KMALLOC_LIMIT				(128L * 1024)
#define	PAGE_RESERVE(vpa)			mem_map_reserve(MAP_NR((vpa)))
#define	PAGE_UNRESERVE(vpa)			mem_map_unreserve(MAP_NR((vpa)))
#define	PCI_DEVICE_LOOP(p)			for (p=pci_devices;p;p=p->next)
#define	PCI_ENABLE_DEVICE(pci)		0
#define	PROC_GET_INFO(pro,fun)		(pro)->get_info = (fun)
#define	REGION_IO_CHECK(a,s)		check_region(a,s)
#define	REGION_IO_RELEASE(a,s)		release_region(a,s)
#define	REGION_IO_REQUEST(a,s,n)	(void*) (request_region(a,s,n), 1)
#define	REGION_MEM_CHECK(a,s)		0
#define	REGION_MEM_RELEASE(a,s)
#define	REGION_MEM_REQUEST(a,s,n)	(void*) 1
#define	REMAP_PAGE_RANGE(v,f,t,s,p)	remap_page_range(f,t,s,p)
#define	SET_CURRENT_STATE(s)		current->state = (s); mb()
#define	SET_MODULE_OWNER(p)
#define	VADDR_T						unsigned long
#define	VIRT_TO_PAGE(p)				(mem_map + MAP_NR((p)))
#define	VM_OFFSET_BYTES(vma)		((vma)->vm_offset)
#define	VM_OPS_NOPAGE(vmo,fun)		(vmo).nopage = (fun)
#define	VM_OPS_UNMAP(vmo,fun)		(vmo).unmap = (fun)
#define	VM_RESERVED					0
#define	WAIT_QUEUE_ENTRY_INIT(w,c)	(w)->task = (c)
#define	WAIT_QUEUE_ENTRY_T			struct wait_queue
#define	WAIT_QUEUE_HEAD_INIT(q)		init_waitqueue((q))
#define	WAIT_QUEUE_HEAD_T			struct wait_queue*

#define	IRQ_REQUEST(dv,fnc)			request_irq((dv)->pci->irq,				\
												(fnc),						\
												SA_SHIRQ,					\
												DRV_DEV_DEVICE_NAME_LOWER,	\
												(dv))



/* prototypes	**************************************************************/

void			irq_isr(int irq, void* dev_id, struct pt_regs* regs);

unsigned long	mmap_nopage(struct vm_area_struct*	vma,
							unsigned long			address,
							int						unused);

void		mmap_unmap(	struct vm_area_struct*	vma,
				unsigned long		addr,
				size_t			len);

int				proc_get_info(	char*	page,
								char**	start,
								off_t	offset,
								int		count,
								int		dummy);



#endif
#endif

