// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/gpio/lib/data.c $
// $Rev: 30430 $
// $Date: 2014-10-07 14:49:48 -0500 (Tue, 07 Oct 2014) $

#include <string.h>

#include "main.h"



//*****************************************************************************
U32 data_cap_get(void* dev, U8* data_cap, U8* cfg_mask)
{
	U8	cfg_mask_tmp	= 0;
	U8	data_cap_tmp	= 0;
	U32	status;
	U32	sts;

	status	= data_exp_cap_get(dev, &data_cap_tmp, &cfg_mask_tmp);

	if (data_cap_tmp == 0)
	{
		sts		= data_sim_cap_get(&data_cap_tmp, &cfg_mask_tmp);
		status	= (status == GSC_SUCCESS) ? sts : status;
	}

	if (data_cap)
		data_cap[0]	= data_cap_tmp;

	if (cfg_mask)
		cfg_mask[0]	= cfg_mask_tmp;


	return(status);
}



//*****************************************************************************
U32 data_enable_get(void* dev, U8* cfg_en)
{
	U8	cap			= 0;
	U8	cfg_en_tmp	= 0;
	U8	cfg_mask	= 0;
	U32	status;
	U32	sts;

	for (;;)	// A convenience loop.
	{
		status	= gpio_dev_cap_get(dev, &cap, NULL, &cfg_mask);

		if (status != GSC_SUCCESS)
			break;

		if (((cap & HPDI32_GPIO_CAP_DATA_TX) == 0) &&
			((cap & HPDI32_GPIO_CAP_DATA_RX) == 0))
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cfg_mask == 0)		// There is nothing to access.
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cap & HPDI32_GPIO_CAP_DATA_EXP)
		{
			// The GPIO registers are supported.
			sts		= data_exp_enable_get(&cfg_en_tmp);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else if (cap & HPDI32_GPIO_CAP_DATA_SIM)
		{
			// The GPIO uses the receiver and the transmitter.
			sts		= data_sim_enable_get(dev, &cfg_en_tmp);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else
		{
			// This board has no GPIO data functionality.
			sts		= GSC_UNSUPPORTED_FUNCTION;
			status	= (status == GSC_SUCCESS) ? sts : status;
		}

		if (cfg_en)
			cfg_en[0]	= cfg_en_tmp;

		break;
	}

	return(status);
}



//*****************************************************************************
U32 data_enable_set(void* dev, U8 cfg_en, U8 cfg_dir, U32 io_bin)
{
	U8	cap			= 0;
	U8	cfg_mask	= 0;
	U32	status;
	U32	sts;

	for (;;)	// A convenience loop.
	{
		status	= gpio_dev_cap_get(dev, &cap, NULL, &cfg_mask);

		if (status != GSC_SUCCESS)
			break;

		if (((cap & HPDI32_GPIO_CAP_DATA_TX) == 0) &&
			((cap & HPDI32_GPIO_CAP_DATA_RX) == 0))
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cfg_mask == 0)		// There is nothing to access.
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cap & HPDI32_GPIO_CAP_DATA_EXP)
		{
			sts		= data_exp_enable_set(dev, cfg_en, cfg_dir, io_bin);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else if (cap & HPDI32_GPIO_CAP_DATA_SIM)
		{
			sts		= data_sim_enable_set(dev, cfg_en, cfg_dir, io_bin);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else
		{
			sts		= GSC_UNSUPPORTED_FUNCTION;
			status	= (status == GSC_SUCCESS) ? sts : status;
		}

		break;
	}

	return(status);
}



//*****************************************************************************
U32 data_dir_out_get(void* dev, U8* cfg_dir)
{
	U8	cap			= 0;
	U8	cfg_dir_tmp	= 0;
	U8	cfg_mask	= 0;
	U32	status;
	U32	sts;

	for (;;)	// A convenience loop.
	{
		status	= gpio_dev_cap_get(dev, &cap, NULL, &cfg_mask);

		if (status != GSC_SUCCESS)
			break;

		if (((cap & HPDI32_GPIO_CAP_DATA_TX) == 0) &&
			((cap & HPDI32_GPIO_CAP_DATA_RX) == 0))
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cfg_mask == 0) // There is nothing to access.
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cap & HPDI32_GPIO_CAP_DATA_EXP)
		{
			sts		= data_exp_dir_out_get(dev, &cfg_dir_tmp);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else if (cap & HPDI32_GPIO_CAP_DATA_SIM)
		{
			sts		= data_sim_dir_out_get(dev, &cfg_dir_tmp);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else
		{
			sts		= GSC_UNSUPPORTED_FUNCTION;
			status	= (status == GSC_SUCCESS) ? sts : status;
		}

		if (cfg_dir)
			cfg_dir[0]	= cfg_dir_tmp;

		break;
	}

	return(status);
}



//*****************************************************************************
U32 data_dir_out_set(void* dev, U8 cfg_dir, U32 io_bin)
{
	U8	cap			= 0;
	U8	cfg_en		= 0;
	U8	cfg_mask	= 0;
	U32	status;
	U32	sts;

	for (;;)	// A convenience loop.
	{
		status	= gpio_dev_cap_get(dev, &cap, NULL, &cfg_mask);

		if (status != GSC_SUCCESS)
			break;

		if (((cap & HPDI32_GPIO_CAP_DATA_TX) == 0) &&
			((cap & HPDI32_GPIO_CAP_DATA_RX) == 0))
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cfg_mask == 0) // There is nothing to access.
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		status	= data_enable_get(dev, &cfg_en);

		if (status != GSC_SUCCESS)
			break;

		if (cap & HPDI32_GPIO_CAP_DATA_EXP)
		{
			sts		= data_exp_dir_out_set(dev, cfg_dir, io_bin);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else if (cap & HPDI32_GPIO_CAP_DATA_SIM)
		{
			sts		= data_sim_dir_out_set(dev, cfg_dir, io_bin);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else
		{
			sts		= GSC_UNSUPPORTED_FUNCTION;
			status	= (status == GSC_SUCCESS) ? sts : status;
		}

		break;
	}

	return(status);
}



//*****************************************************************************
U32 hpdi32_gpio_data_rx(void* dev, U32* io_bin)
{
	U8	cap			= 0;
	U8	cfg_mask	= 0;
	U32	io_bin_tmp	= 0;
	U32	status;
	U32	sts;

	for (;;)	// A convenience loop.
	{
		status	= gpio_dev_cap_get(dev, &cap, NULL, &cfg_mask);

		if (status != GSC_SUCCESS)
			break;

		if ((cap & HPDI32_GPIO_CAP_DATA_RX) == 0)
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cfg_mask == 0) // There is nothing to access.
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cap & HPDI32_GPIO_CAP_DATA_EXP)
		{
			sts		= data_exp_rx(dev, &io_bin_tmp);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else if (cap & HPDI32_GPIO_CAP_DATA_SIM)
		{
			sts		= data_sim_rx(dev, &io_bin_tmp);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else
		{
			sts		= GSC_UNSUPPORTED_FUNCTION;
			status	= (status == GSC_SUCCESS) ? sts : status;
		}

		if (io_bin)
			io_bin[0]	= io_bin_tmp;

		break;
	}

	return(status);
}



//*****************************************************************************
U32 hpdi32_gpio_data_tx(void* dev, U32 io_bin)
{
	U8	cap			= 0;
	U8	cfg_mask	= 0;
	U32	status;
	U32	sts;

	for (;;)	// A convenience loop.
	{
		status	= gpio_dev_cap_get(dev, &cap, NULL, &cfg_mask);

		if (status != GSC_SUCCESS)
			break;

		if ((cap & HPDI32_GPIO_CAP_DATA_TX) == 0)
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cfg_mask == 0) // There is nothing to access.
		{
			status	= GSC_UNSUPPORTED_FUNCTION;
			break;
		}

		if (cap & HPDI32_GPIO_CAP_DATA_EXP)
		{
			// The GPIO registers are supported.
			sts		= data_exp_tx(dev, io_bin);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else if (cap & HPDI32_GPIO_CAP_DATA_SIM)
		{
			// The GPIO uses the receiver and the transmitter.
			sts		= data_sim_tx(dev, io_bin);
			status	= (status == GSC_SUCCESS) ? sts : status;
		}
		else
		{
			// This board has no GPIO data functionality.
			sts		= GSC_UNSUPPORTED_FUNCTION;
			status	= (status == GSC_SUCCESS) ? sts : status;
		}

		break;
	}

	return(status);
}


