// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/gpio/utils/util_gpio_config_get.c $
// $Rev: 30431 $
// $Date: 2014-10-07 14:50:22 -0500 (Tue, 07 Oct 2014) $

#include <stdio.h>

#include "hpdi32_utils.h"
#include "hpdi32_gpio_utils.h"



//*****************************************************************************
int dev_gpio_config_get(void* dev, int index, int verbose, U8* cfg_en, U8* cfg_dir)
{
	U8	cfg_dir_tmp;
	U8	cfg_en_tmp;
	int	errs	= 0;
	U32	status	= GSC_SUCCESS;

	if (verbose)
		label_text_index("GPIO Get Configuration", index);

	status	= hpdi32_gpio_config_get(dev, &cfg_en_tmp, &cfg_dir_tmp);
	errs	+= (status == GSC_SUCCESS) ? 0 : 1;

	if (verbose)
	{
		printf(	"%s  (Enable 0x%02lX, Outputs 0x%02lX)\n",
				errs ? "FAIL <---" : "PASS",
				(long) cfg_en_tmp,
				(long) cfg_dir_tmp);
	}

	if (cfg_en)
		cfg_en[0]	= cfg_en_tmp;

	if (cfg_dir)
		cfg_dir[0]	= cfg_dir_tmp;

	return(errs);
}


