// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/utils/util_count.c $
// $Rev: 30390 $
// $Date: 2014-09-18 12:16:55 -0500 (Thu, 18 Sep 2014) $

#include <stdio.h>

#include "hpdi32_utils.h"



/******************************************************************************
*
*	Function:	dev_board_count
*
*	Purpose:
*
*		Count the number of installed HPDI32 boards.
*
*	Arguments:
*
*		None.
*
*	Returned:
*
*		>= 0	The number of boards found.
*		< 0		The number of errors encounterred here.
*
******************************************************************************/

int dev_board_count(void)
{
	U8	count;
	int	errs;
	int	ret;
	U32	status;

	label_text("HPDI32 Board Count");
	status	= hpdi32_board_count(&count);
	errs	= label_fail_func(1, "hpdi32_board_count", status);

	if (errs)
	{
		ret	= -1;
	}
	else if (count == 0)
	{
		ret	= 0;
		printf("No boards found\n");
	}
	else
	{
		ret	= (int) count;
		printf("%d\n", ret);
	}

	return(ret);
}


