// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/utils/util_sleep.c $
// $Rev: 30390 $
// $Date: 2014-09-18 12:16:55 -0500 (Thu, 18 Sep 2014) $

#include <unistd.h>

#include "hpdi32_utils.h"



/******************************************************************************
*
*	Function:	sleep_ms
*
*	Purpose:
*
*		Sleep for the given number of milliseconds. The OS may sleep longer
*		than requested, much longer, due to factors outside our control.
*
*	Arguments:
*
*		ms	The number of milleseconds to sleep. If zero or less is given we
*			use one.
*
*	Returned:
*
*		None.
*
******************************************************************************/

void sleep_ms(long ms)
{
	for (;;)
	{
		if (ms == 0)
			break;

		if (ms > 10)
		{
			usleep(10000);
			ms	-= 10;
			continue;
		}

		usleep(ms * 1000);
		break;
	}
}


