// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/utils/util_string.c $
// $Rev: 30390 $
// $Date: 2014-09-18 12:16:55 -0500 (Thu, 18 Sep 2014) $

#include <ctype.h>
#include <string.h>

#include "hpdi32_utils.h"



/******************************************************************************
*
*	Function:	stricmp
*
*	Purpose:
*
*		Compare two strings as if by strcmp, but with case insensitivity.
*
*	Arguments:
*
*		str1	The first string to compare.
*
*		str2	The second string to compare.
*
*	Returned:
*
*		< 0		str1 is less than str2.
*		0		Both strings are equal.
*		> 0		str1 is greater than str2.
*
******************************************************************************/

int stricmp(const char* str1, const char* str2)
{
	int	ret;

	if ((str1 == NULL) && (str2 == NULL))
	{
		ret	= 0;
	}
	else if (str1 == NULL)
	{
		ret	= 1;
	}
	else if (str2 == NULL)
	{
		ret	= 1;
	}
	else
	{
		for (;; str1++, str2++)
		{
			if ((str1[0] == 0) || (str2[0] == 0))
			{
				ret	= strcmp(str1, str2);
				break;
			}

			if ((isalpha(str1[0])) && (isalpha(str2[0])))
				ret	= toupper(str1[0]) - toupper(str2[0]);
			else
				ret	= str1[0] - str2[0];

			if (ret)
				break;
			else
				continue;
		}
	}

	return(ret);
}


