// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32/HPDI32_Linux_sdk_6.x.x_GSC_DN/xfer/main.h $
// $Rev: 30446 $
// $Date: 2014-10-07 16:57:57 -0500 (Tue, 07 Oct 2014) $

#ifndef __MAIN_H__
#define __MAIN_H__

#include "hpdi32_utils.h"



// #defines *******************************************************************

#define	VERSION				"1.6"
// 1.6	Fixed a command line parsing bug.
//		Adjust output column alignment.
// 1.5	LINTed the sources.
// 1.4	Combined utility headers into hpdi32_utils.h.
//		Updated the usage output text.
// 1.3	Added TxAutoStart and TxRemoteThrottle options.
//		Converted to use API buffers.
// 1.02	Added host os identification.
// 1.01	Ported to the SDK.
// 1.00	Initial release.

#define	ARRAY_ELEMENTS(a)			(sizeof((a))/sizeof((a)[0]))

#define	BLOCK_COUNT_LIMIT			(100L * 1024L * 1024L)
#define	BLOCK_SAMPLES_LIMIT			(10L * 1024L * 1024L)

#define	TRANSFER_PERIOD_LIMIT_DAYS	7

#define	SECONDS_PER_YEAR	(60L * 60 * 24 * 7 * 52)
#define	SECONDS_PER_WEEK	(60L * 60 * 24 * 7)
#define	SECONDS_PER_DAY		(60L * 60 * 24)
#define	SECONDS_PER_HOUR	(60L * 60)
#define	SECONDS_PER_MINUTE	(60L)



// variables ******************************************************************

extern	U32	block_count;
extern	U32	block_samples;
extern	U32	io_clock;



// prototypes *****************************************************************

void	actual_duration(long begin);
U32		estimate_duration(U32 clock, U32 size, double bytes);
void	format_value(U32 u32, const char* units);
U32		read_config_file(void* device, const char* name);
U32		my_mem_alloc(void* device, U32 which, U32 size, void** ptr);
void	my_mem_free(void* device, U32 which);
U32		rx_process(void* device);
U32		show_data_rate(U32 which, U32 clock, U32 size);
U32		show_data_set(void* device, U32 which, unsigned long* size, double* bytes);
U32		test_status(U32 status, const char* service);
U32		tx_process(void* device);
U32		tx_rx_tristate(void* device);



#endif
